diff --git a/modules/reindex/src/test/java/org/elasticsearch/index/reindex/CancelTests.java b/modules/reindex/src/test/java/org/elasticsearch/index/reindex/CancelTests.java
index 3e50363801056..259007843a15a 100644
--- a/modules/reindex/src/test/java/org/elasticsearch/index/reindex/CancelTests.java
+++ b/modules/reindex/src/test/java/org/elasticsearch/index/reindex/CancelTests.java
@@ -177,7 +177,7 @@ private void testCancel(String action, AbstractBulkByScrollRequestBuilder<?, ?>
         try {
             response = future.get(30, TimeUnit.SECONDS);
         } catch (Exception e) {
-            if (ExceptionsHelper.unwrap(e, TaskCancelledException.class) != null) {
+            if (ExceptionsHelper.unwrapCausesAndSuppressed(e, t -> t instanceof TaskCancelledException).isPresent()) {
                 return; // the scroll request was cancelled
             }
             String tasks = client().admin().cluster().prepareListTasks().setParentTaskId(mainTask.getTaskId())
